const nsIAccessible = Components.interfaces.nsIAccessible;
//// vordefinierte Navigationsleisten
const NAVBAR_1 = "bci-nav-bar";
const NAVBAR_1_BUTTONS = "bci-nav-bar-buttons";

////////////////////////////////////////////////////////////////////////////
//// class Prefs

function Prefs()
{
dumpln("test");
  dd("Initialising preferences in bci-prefs.js...");
}

Prefs.prototype = 
{

// ::::::::::::::::::::::::: Benutzereinstellungen ::::::::::::::::::::::::::

  /* startCommand: Befehl der ausgefhrt wird, nachdem Nessi sich mit dem BCI
   * verbunden hat. */
  startCommand:('loadURI( "file:///C:/moz/local_html/index.html")'),
  

  /* Lnge der Lesepause (in Sekunden) */
  viewPageDelay: 0,

  /* Wie lange sollen Informationsdialoge angezeigt werden? (in Sekunden) */
  informationMessageDelay: 10,

  /* Soll ein Dialog den Feedback berdecken whrend eine Seite geladen wird?
   * Beim Surfen von Festplatte lieber auf "false" setzen. */
  showLoadingPageDialog: false, // [true,false]

  /* CSS style Anweisung: Breite und Art der Rnder der farbigen Kstchen */
  outlineStyle: "3px solid", // [solid, dotted, dashed, double]
  targetOutlineStyle: "3px dashed", // Markierung fr Zielknoten 

  /* Auswahlstruktur.
   * NB: 0-10 sollten nur mit 2 Klassifikationsklassen verwendet werden.
   * 0: class 1=select, class 2=scan (LSP1,5 NICHT VERWENDEN)
   * 1: LSP1 : class 1=select, class 2=scan 
   * 2: verbessertes LSP2 : 1=select, 2=scan
   * 8: scan mit 1 (red), select mit 2 (green) (LSP)
   * 10: Direktauswahl: Whlt immer mit Klasse 1 und 2, kein Scanning */
  treeType: 10, // [0-10]

  /* Anzahl der Schritte, bis ein "Zurck" Knoten eingefgt wird.
   * z.B. fgt "0" keine "Zurck" Knoten ein, "2" alle 2 Schritte. 
   * In der Diplomarbeit wird dieser Parameter "m" genannt. Er ist nur fr
   * |treeType| >= 10 sinnvoll, und sollte auf "2" gesetzt werden. */
  verifyFrequency: 2, // [0-5]

  /* Anzahl Besttigungen, die direkt vor Auswahl eines Elements eingefgt
   * werden (aus Zeitmangel noch nicht implementiert) */
  finalVerify: 0, // [0-10]
    
  /* Art der auswhlbaren Elemente die dem Patienten zur Wahl geboten werden */
  roles: [30, //"ROLE_LINK",
          42, //"ROLE_TEXT",                    // Textfelder und Text in Links
          43], //"ROLE_PUSHBUTTON",    // fr Navigationsleiste - NIE ENTFERNEN
  //40, // "ROLE_GRAPHIC"                         // findet Grafiken ohne Links
  //34, // "ROLE_LISTITEM",
  //44, // "ROLE_CHECKBUTTON",
  //45, // "ROLE_RADIOBUTTON",
  //46, // "ROLE_COMBOBOX",
  //47, // "ROLE_DROPLIST",
  //49, // "ROLE_DIAL",
  //51, // "ROLE_SLIDER",
  //52, // "ROLE_SPINBUTTON",
  //56, 57, 58, //"ROLE_BUTTONDROPDOWN", "ROLE_BUTTONMENU", "ROLE_BUTTONDROPDOWNGRID",
  //62], //"ROLE_SPLITBUTTON"],

  /* Zu verwendende Navigationsleiste. Es knnen weitere definiert werden. */
  menuSource: "content", //NAVBAR_1_BUTTONS,

  /* Falls |true|, darf die Leiste zur Eingabe einer Webadresse ausgewhlt
   * werden. Sollte erst eingefhrt werden, wenn der Patient mit den restlichen
   * Funktionen gut vertraut ist. */
  allowURL: false, // [true,false]

  /* Hier wird der Befehl angegeben, den Nessi ausfhren soll wenn drei 
   * Trials lang nichts passiert. Die Befehle stehen in bci-static.js
   * in der Klasse |Commands| */
  autoStep: "Commands.prototype.getInstance().browserBack();",


  // :::::::::::::::::::::::::: Virtuelles Keyboard :::::::::::::::::::::::::::

  /* Gibt die Positionierung des virtuellen Keyboards auf dem Bildschirm an.
   * 0: ganz oben, 1: ber Texteingabe, 2: unter Texteingabe, 3: ganz unten */
  keyboardPosition: 2, // [0-3]

  keyboardContent: "chrome://bci/content/vk_de-lsp-log.html",//"chrome://bci/content/vk_de-lsp.html", // siehe Verzeichnis
  keyboardContentAddress: "chrome://bci/content/vk_de-address.html", // Keyboard fr Adresseingabe
  keyboardContentSend: "chrome://bci/content/vk_de-send.html", // Keyboard fr Mailtexteingabe und Versenden


  // :::::::::::::::::::::: Technische Einstellungen ::::::::::::::::::::::::::

  /* Falls "true", wird das Fenster fr die Lesepause automatisch links
   * neben dem Browser Fenster platziert und berdeckt alles 
   * ACHTUNG: Funktioniert nicht mit zwei Bildschirmen! */
  autoSizeWindow: false,

  /* Hier sollte die horizontale Auflsung des Bildschirms angegeben werden.
   * Wenn zwei Bildschirme verwendet werden, steht hier die Auflsung des
   * linken (ersten) Bildschirms (Nessi wird auf dem rechten angezeigt). */
  primaryDisplaySize: 1024,

  /* Farben fr die Rahmen, in der Reihenfolge der Klassifikationsklassen */
  classColors: "FF00C0-00FFC0-0000FF-FF8C00-000000-000000-000000-000000",
  // Fr Herr Salzmann: 1=grn=Auswahl, 2=rot=scan
  //    Im AppConnect Filter mssen die Klassen vertauscht werden!
  //    BCResultMap: 0 2 0 0 1 0 0 0 0
  
  /* Farben fr die Target-Rahmen , in der Reihenfolge der Klassifitkationsklassen */
  targetClassColors: "A00079-00A078-0000A0-A05700-000000-000000-000000-000000",
  
  
  
  /* Dateiname fr Datei, in der Matrizen abgespeichert werden.
   Besteht aus dem Wort "performance" und dem aktuellen Datum:
   performance_TT_MM_JJJJ, z.B. performance_17_11_2005 */
  filename: "c:\\moz\\source\\mozilla\\extensions\\bci\\resources\\content\\performance", 
  //filename: "c:\\Dokumente und Einstellungen\\mike home\\Desktop\\performance",
  
  /* HTML-Seite, die im Anzeigefenster fr Trefferrate geladen wird
    (deutsch oder englisch) */
  logWindowHTML: "chrome://bci/content/logWindow_en.html" , //englisch  
  //logWindowHTML: "chrome://bci/content/logWindow_de.html" ,  //deutsch


  /* Defaulteinstellung fr die Anzahl der Klassifikationsklassen. 
   * Wird nur verwendet wenn das BCI keinen Wert sendet. Wert muss > 2 sein! */
  defaultClassCount: 2, // [2-8]
    
  /* Verbindungsparameter */
  host: "localhost",
  port: 4100,

  /* Debuggingparameter */
  addDateToDotFile: 0,
  dotFileVerbosity: 2, // [0-2]
  
  /* Daten fr Mailaccount */
  mailSubject: "Nachricht von bciuser",
  smtpPassword: "IwidG4iG",
  
 
}
