/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Urban Rage Software code.
The Initial Developer of the Original Code is Eric Plaster.

Portions created by Urban Rage Software are
Copyright (C) 2001 Urban Rage Software.  All
Rights Reserved.

Contributor(s): Eric Plaster <plaster@urbanrage.com)> (original author)
                Michael Bensch (modifications for bcimoz)
*/

ddk = function (str) {dump ("---kbd: " + str + "\n");}
//ddk = function (){};

var gEditableText = null; //type nsIAccessibleEditableText
var gAccess = null; //type nsIAccessible
/* AVAILABLE METHODS:
---kbd: setTextContents
---kbd: insertText
---kbd: copyText
---kbd: cutText
---kbd: deleteText
---kbd: pasteText
---kbd: caretOffset
---kbd: characterCount
---kbd: selectionCount
---kbd: getText
---kbd: getTextAfterOffset
---kbd: getTextAtOffset
---kbd: getCharacterAtOffset
---kbd: getAttributeRange
---kbd: getTextBeforeOffset
---kbd: getCharacterExtents
---kbd: getOffsetAtPoint
---kbd: getSelectionBounds
---kbd: setSelectionBounds
---kbd: addSelection
---kbd: removeSelection
*/

var count; // bug hack
var inputField = null;

/* We cannot position the window in |onLoad()| because its dimensions are
 * not available yet. We have defined |onOpenKeyboard| in bci-handlers.js
 * which is executed 200ms after |window.open| */
function onLoad()
{
  setTimeout("go();",1000);

}

/**
 * We try to get the accessible Interface to the text field to work with that.
 * If this is not possible (url bar, for example) we use |inputField| as a 
 * normal DOM element.
 */

function go() 
{
 try {
    gAccess = window.arguments[0];
    ddk("gAccess" + gAccess);
    gEditableText = gAccess.
      QueryInterface(Components.interfaces["nsIAccessibleEditableText"]);
 } catch (ex) { // assume we have been given a normal DOM element
    ddk("Failed to find editable text field. Assuming DOM element.\n" + ex);
    inputField = gAccess.getDOMNode(); // normal html input field 
    ddk("Using inputField: " + inputField);
    inputField.value = "";
    //window.close();
  }
  count = 0;
  //ddk("win size: " + window.outerWidth + ", " + window.outerHeight);
}


function onClose() {
  ddk("onClose");
  if (!inputField) inputField = gAccess.getDOMNode();
  if (inputField) {
    var str = new String(inputField.value);
    str.replace(/-/g," "); // modifier g finds all occurences of ":"
  }  
  if (window.opener)
    window.opener.manager.msgWin = null; 
  if (window.opener.manager.activeMenu) {
    window.opener.manager.activeMenu = null;
    if (inputField) {
      window.opener.loadURI(inputField.value);
    } else {
      // unneccessary when closing the whole app - this should not get called
      window.opener.manager.createMenu("content",1); // 1 = display immediately
    }
  }
}

function spell(aLetter) {

  count++;
  ddk("count is " + count);
  if (inputField)
    inputField.value += aLetter.toLowerCase();
  else 
    gEditableText.insertText(aLetter.toLowerCase(), count);
  //reward(gAccess);
  window.opener.manager.activeMenu.step(-1000); // move to top of menu
}

function backSpace() {
  ddk("backSpace: should delete a character.");
  if (inputField)
    inputField.value = inputField.value.substr(0,inputField.textLength-1);
  else
    gEditableText.deleteText(count-1,count);
  if (count > 0)
    count--;
  window.opener.manager.activeMenu.step(-1000); // move to top of menu
}

function reward(anEdTextAcc) {
  var domNode = null; // type nsIDOMNode
  domNode = anEdTextAcc.accGetDOMNode();
  if ( domNode ) {
    ddk("dom node OK");
    try { 
      // returns the value of the "bci_task" attribute
      var task = domNode.getAttribute("bci_task"); 
    } catch ( ex ) {
      ddk("ex:" + ex);
    }
    ddk("task: " + task);
    var written = anEdTextAcc.getText(0,20);
    ddk("written: " + written);
   
    if (task.toUpperCase() == written.toUpperCase()) {
      ddk("gut!!!!!!!!!");
    }
  }
}


function send() {
  ddk("send()");
  window.opener.sendMessage();
}

//keyboard is closed, we return to GUI
function returnToMail() {
  ddk("returnToMail()");
  if (window.opener) {
    ddk("keyboard is closed");
    window.opener.manager.msgWin.close();
    window.opener.manager.msgWin = null; 
  }
  if (window.opener.manager.activeMenu) {
    window.opener.manager.activeMenu = null;
  }
  // 
  window.opener.manager.createMenu("content",1); // 1 = display immediately  
}


function isSelected() {
  if(window.event.button==1) {
    ddk("left button was pressed....select as target");
  }
  else {
    ddk("another button was pressed...");
  }
}

function selectTarget(event) {
  ddk("selectTarget()");
  var mousebutton = event.which;
  ddk("mousebutton " + mousebutton);
  if (mousebutton==3) {
    var element = event.target;
    window.opener.select(event.target);
  }   
}

function setAddress(aAdress) {
  ddk("setAddress");
  inputField.value = aAdress;
  window.opener.manager.activeMenu.step(-1000); // move to top of menu
}

function openNextKeyboard() {
  ddk("openNextKeyboard()");
  window.opener.nextKeyboard();
}